Subject: [bess] Encoding a 20 bit label in a 24 bit field.

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Mon, 15 Oct 2018 20:20:41 +0000

We have proposed the following erratum for RFC 7432.

Opinions?

Regards,
Jakob.

-----Original Message-----
From: RFC Errata System <[email-masked]> 
Sent: Friday, October 12, 2018 12:37 PM
To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
Subject: [Technical Errata Reported] RFC7432 (5523)

The following errata report has been submitted for RFC7432,
"BGP MPLS-Based Ethernet VPN".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5523

--------------------------------------
Type: Technical
Reported by: Krishnamoorthy Arumugham <[email-masked]>

Section: 7

Original Text
-------------
Clarifications to following sub-sections:
Section 7.1
Section 7.2
Section 7.5

Corrected Text
--------------
Section 7.1:
Add below text to the section 7.1 regarding the encoding 
of MPLS label:

"The value of the 20-bit MPLS label is encoded in the 
high-order 20 bits of the 3 bytes MPLS Label field."

Section 7.2:
Add below text to the section 7.2 regarding the encoding
of both the MPLS label fields:

"The value of the 20-bit MPLS label is encoded in the 
high-order 20 bits of the 3 bytes MPLS Label field for
both MPLS Label1 and MPLS Label2."

Section 7.5:
Add below text to the section 7.5 regarding the encoding
of ESI Label fields:

"The value of the 20-bit MPLS label is encoded in the 
high-order 20 bits of the ESI Label field."

Notes
-----
MPLS label is a 20-bit value and is stored in a 3 bytes field in a packet. The 20-bit MPLS label value is generally stored in higher order 20 bits of the 3 byte label field. The exact encoding to be followed for storing MPLS label values are not explicitly mentioned in the RFC 7432 under section 7.1, 7.2 and 7.5 for different types of EVPN routes. This lead to ambiguity in different implementations. Hence a clarification is required.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC7432 (draft-ietf-l2vpn-evpn-11)
--------------------------------------
Title               : BGP MPLS-Based Ethernet VPN
Publication Date    : February 2015
Author(s)           : A. Sajassi, Ed., R. Aggarwal, N. Bitar, A. Isaac, J. Uttaro, J. Drake, W. Henderickx
Category            : PROPOSED STANDARD
Source              : Layer 2 Virtual Private Networks
Area                : Routing
Stream              : IETF
Verifying Party     : IESG

---

From: Zhuangshunwan <[email-masked]>
Date: Tue, 16 Oct 2018 01:01:50 +0000

It is good to make this explicit. This ambiguity has led to some unnecessary interworking problems.

Should we also need to explicitly define the "bottom of stack" bit in the low-order bit of the 3-octet label field?

Thanks,
Shunwan

-----Original Message-----
From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
Sent: Tuesday, October 16, 2018 4:21 AM
To: BESS <[email-masked]>
Subject: [bess] Encoding a 20 bit label in a 24 bit field.

Opinions?

Regards,
Jakob.

-----Original Message-----
From: RFC Errata System <[email-masked]>
Sent: Friday, October 12, 2018 12:37 PM
To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
Subject: [Technical Errata Reported] RFC7432 (5523)

The following errata report has been submitted for RFC7432, "BGP MPLS-Based Ethernet VPN".

Section: 7

Original Text
-------------

Corrected Text
--------------
Section 7.1:
Add below text to the section 7.1 regarding the encoding of MPLS label:

"The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the 3 bytes MPLS Label field."

Section 7.2:
Add below text to the section 7.2 regarding the encoding of both the MPLS label fields:

"The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the 3 bytes MPLS Label field for both MPLS Label1 and MPLS Label2."

Section 7.5:
Add below text to the section 7.5 regarding the encoding of ESI Label fields:

"The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the ESI Label field."

Notes
-----

Instructions:
-------------

_______________________________________________
BESS mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/bess

---

From: "Jakob Heitz (jheitz)" <[email-masked]>
Date: Tue, 16 Oct 2018 01:23:42 +0000

How about:
The lower order 4 bits SHOULD be sent as 0 and ignored on receipt.

Regards,
Jakob.

-----Original Message-----
From: Zhuangshunwan <[email-masked]> 
Sent: Monday, October 15, 2018 6:02 PM
To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
Subject: RE: Encoding a 20 bit label in a 24 bit field.

Thanks,
Shunwan

-----Original Message-----
From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
Sent: Tuesday, October 16, 2018 4:21 AM
To: BESS <[email-masked]>
Subject: [bess] Encoding a 20 bit label in a 24 bit field.

Opinions?

Regards,
Jakob.

-----Original Message-----
From: RFC Errata System <[email-masked]>
Sent: Friday, October 12, 2018 12:37 PM
To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
Subject: [Technical Errata Reported] RFC7432 (5523)

Section: 7

Original Text
-------------

Corrected Text
--------------
Section 7.1:

Section 7.2:

Section 7.5:

Notes
-----

Instructions:
-------------

---

From: Zhuangshunwan <[email-masked]>
Date: Tue, 16 Oct 2018 01:36:54 +0000

It looks good to me. I have not found any specific purposes of these bits in RFC7432. Maybe I missed something.

Thanks, 
Shunwan

-----Original Message-----
From: Jakob Heitz (jheitz) [mailto:[email-masked]] 
Sent: Tuesday, October 16, 2018 9:24 AM
To: Zhuangshunwan <[email-masked]>; BESS <[email-masked]>
Subject: RE: Encoding a 20 bit label in a 24 bit field.

How about:

Regards,
Jakob.

-----Original Message-----
From: Zhuangshunwan <[email-masked]>
Sent: Monday, October 15, 2018 6:02 PM
To: Jakob Heitz (jheitz) <[email-masked]>; BESS <[email-masked]>
Subject: RE: Encoding a 20 bit label in a 24 bit field.

Thanks,
Shunwan

-----Original Message-----
From: BESS [mailto:[email-masked]] On Behalf Of Jakob Heitz (jheitz)
Sent: Tuesday, October 16, 2018 4:21 AM
To: BESS <[email-masked]>
Subject: [bess] Encoding a 20 bit label in a 24 bit field.

Opinions?

Regards,
Jakob.

-----Original Message-----
From: RFC Errata System <[email-masked]>
Sent: Friday, October 12, 2018 12:37 PM
To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Giles Heron (giheron) <[email-masked]>; [email-masked]
Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>; [email-masked]; [email-masked]
Subject: [Technical Errata Reported] RFC7432 (5523)

Section: 7

Original Text
-------------

Corrected Text
--------------
Section 7.1:

Section 7.2:

Section 7.5:

Notes
-----

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please use "Reply All" to discuss whether it should be verified or rejected. When a decision is reached, the verifying party can log in to change the status and edit the report, if necessary.

---

From: John E Drake <[email-masked]>
Date: Tue, 16 Oct 2018 12:27:42 +0000

I don't think that's a good idea because depending upon their position in the stack, these labels may not be at the bottom of the stack.

Yours Irrespectively,

John

> From: BESS <[email-masked]> On Behalf Of Zhuangshunwan
> Sent: Monday, October 15, 2018 9:02 PM
> Subject: Re: [bess] Encoding a 20 bit label in a 24 bit field.
> 
> To: Ali Sajassi (sajassi) <[email-masked]>; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; [email-masked];
> [email-masked]; [email-masked]; Giles Heron
> (giheron) <[email-masked]>; [email-masked]
> Cc: Krishnamoorthy Arumugham (karumugh) <[email-masked]>;
> [email-masked]; [email-masked]
> https://urldefense.proofpoint.com/v2/url?u=http-3A__www.rfc-
> 2Deditor.org_errata_eid5523&d=DwICAg&c=HAkYuh63rsuhr6Scbfh0UjBXeM
> K-ndb3voDTXcWzoCI&r=CRB2tJiQePk0cT-h5LGhEWH-
> s_xXXup3HzvBSMRj5VE&m=IvOdDW_zoH5heXCCcs7ke0vmlQ0Hm1yCi17llZn
> BdsY&s=n_iX5KAK2InG-bgMnZHO3o4PH9UZmYKVtes9H7-vA1E&e=
> 
> "The value of the 20-bit MPLS label is encoded in the high-order 20 bits of the
> 3 bytes MPLS Label field for both MPLS Label1 and MPLS Label2."
> 
> Section 7.5:
> MPLS label is a 20-bit value and is stored in a 3 bytes field in a packet. The 20-
> bit MPLS label value is generally stored in higher order 20 bits of the 3 byte
> label field. The exact encoding to be followed for storing MPLS label values
> are not explicitly mentioned in the RFC 7432 under section 7.1, 7.2 and 7.5
> for different types of EVPN routes. This lead to ambiguity in different
> implementations. Hence a clarification is required.
> 
> Instructions:
> -------------
> This erratum is currently posted as "Reported". If necessary, please use
> "Reply All" to discuss whether it should be verified or rejected. When a
> decision is reached, the verifying party can log in to change the status and
> edit the report, if necessary.
> 
> https://urldefense.proofpoint.com/v2/url?u=https-
> 3A__www.ietf.org_mailman_listinfo_bess&d=DwICAg&c=HAkYuh63rsuhr6Sc
> bfh0UjBXeMK-ndb3voDTXcWzoCI&r=CRB2tJiQePk0cT-h5LGhEWH-
> s_xXXup3HzvBSMRj5VE&m=IvOdDW_zoH5heXCCcs7ke0vmlQ0Hm1yCi17llZn
> BdsY&s=xbhjuaPYmhE7YZHdrs0qRQmpbqzoxbsm12LoU1YI5O8&e=
> 
> https://urldefense.proofpoint.com/v2/url?u=https-
> 3A__www.ietf.org_mailman_listinfo_bess&d=DwICAg&c=HAkYuh63rsuhr6Sc
> bfh0UjBXeMK-ndb3voDTXcWzoCI&r=CRB2tJiQePk0cT-h5LGhEWH-
> s_xXXup3HzvBSMRj5VE&m=IvOdDW_zoH5heXCCcs7ke0vmlQ0Hm1yCi17llZn
> BdsY&s=xbhjuaPYmhE7YZHdrs0qRQmpbqzoxbsm12LoU1YI5O8&e=